/*
 * Use trap 31.
 * See gdb/sim/v850/simops.c:OP_10007E0()
 */

/* See gdb/sim/common/nltvals.def (NL_TARGET_v850) */
#define SYS_exit  1
#define SYS_read  3
#define SYS_write 4
#define SYS_open  5
#define SYS_close 6

	.section .text

	.globl	_start
	.type	_start, @function
_start:
	movhi	hi(_estack), r0, sp
	movea	lo(_estack), sp, sp
	jarl	_main, lp

	mov	0, r7
	/* fall through */

	.globl	___r_exit
	.type	___r_exit, @function
___r_exit:
	mov	SYS_exit, r6
	trap	31
	jmp	[lp

	.globl	___r_read
	.type	___r_read, @function
___r_read:
	mov	SYS_read, r6
	trap	31
	jmp	[lp

	.globl	___r_write
	.type	___r_write, @function
___r_write:
	mov	SYS_write, r6
	trap	31
	jmp	[lp

	.globl	___r_open
	.type	___r_open, @function
___r_open:
	mov	SYS_open, r6
	trap	31
	jmp	[lp

	.globl	___r_close
	.type	___r_close, @function
___r_close:
	mov	SYS_close, r6
	trap	31
	jmp	[lp

	.globl	__save_r28_r31
	.globl	__save_r29_r31
	.globl	__save_r30_r31
	.globl	__save_r31
__save_r28_r31:
__save_r29_r31:
__save_r30_r31:
__save_r31:
	addi	-16, sp, sp
	st.w	r28, 12[sp
	st.w	r29, 8[sp
	st.w	r30, 4[sp
	st.w	r31, 0[sp
	jmp	[r10

	.globl	__return_r28_r31
	.globl	__return_r29_r31
	.globl	__return_r30_r31
	.globl	__return_r31
__return_r28_r31:
__return_r29_r31:
__return_r30_r31:
__return_r31:
	ld.w	12[sp, r28
	ld.w	8[sp, r29
	ld.w	4[sp, r30
	ld.w	0[sp, r31
	addi	16, sp, sp
	jmp	[lp
